code	segment	'code'
	assume	cs:code,ds:code

	org	100h

start:	mov	sp,200h			; move stack
	push	ax

	mov	bl,20h			; resize memory block
	mov	ah,4ah
	int	21h

	mov	dx,offset file		; open cartridge file
	mov	ax,3d02h
	int	21h
	jc	exit

	mov	dx,203h			; seek init address
	xor	cx,cx
	mov	bx,ax
	mov	ax,4200h
	int	21h

	mov	dx,offset inst		; write RETF instruction
	mov	cl,1
	mov	ah,40h
	int	21h

	mov	ah,3eh			; close file
	int	21h

	mov	word ptr tail+2,cs	; set segments in param block
	mov	word ptr fcb1+2,cs
	mov	word ptr fcb2+2,cs

	mov	byte ptr term,0dh	; terminate parameter with CR

	mov	dx,offset prog		; execute program
	mov	bx,offset parm
	mov	ax,4b00h
	int	21h

	mov	dx,cs			; create child PSP
	add	dx,21h
	mov	si,word ptr [2]
	mov	ah,55h
	int	21h

	mov	bx,dx			; set current PSP
	mov	ah,50h
	int	21h

	mov	ds,bx			; set segments and stack
	mov	es,bx
	mov	ss,bx
	mov	sp,0fffeh

	mov	bx,0ah			; set termination address
	mov	word ptr [bx],offset back
	mov	word ptr [bx+2],cs

	call	0e000h:8		; call Color Paint

back:	xor	ax,ax			; reset mouse
	int	33h

exit:	ret				; return to DOS

inst	db	0cbh			; RETF instruction
line	db	0dh,' '			; command line length
file	db	'COLORPNT.JRC'		; filename parameter
term	db	0			; terminator
prog	db	'Z:\BOOT.COM'		; program filename
parm	dw	0			; default env seg
tail	dd	offset line		; command line tail pointer
fcb1	dd	5ch			; first FCB pointer
fcb2	dw	6ch			; second FCB pointer

code	ends

	end	start
